﻿using System;
using System.Data;
using System.Windows.Forms;

namespace RDIFramework.Test
{
    using RDIFramework.BizLogic;
    using RDIFramework.Utilities;
    using RDIFramework.WinForm.Utilities;


    public partial class FrmTest : BaseForm
    {
        public FrmTest()
        {
            InitializeComponent();
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            var productAdmin = new FrmProductAdmin {DbLinks = this.DbLinks};
            productAdmin.ShowDialog();
        }

        private void FrmTest_Shown(object sender, EventArgs e)
        {
            SystemInfo.StartupPath = Application.StartupPath;
            this.GetAllDbLinks();
        }

        //调试修改添加
        private void GetAllDbLinks()
        {
            UserConfigHelper.GetConfig();
            this.UserInfo.OpenId = "7d46323d-0091-4bf5-8a13-67fef63a4cd4";
            this.UserInfo.Id = "26F43BC9-AE6D-42D2-BAC9-F4237A949484";
            this.UserInfo.Code = "Administrator";
            this.UserInfo.RealName = "Administrator";
            this.UserInfo.IsAdministrator = true;
            DataTable dtDbLinks = RDIFrameworkService.Instance.DbLinkDefineService.GetDT(this.UserInfo);
            if (dtDbLinks != null && dtDbLinks.Rows.Count > 0)
            {
                foreach (DataRow dataRow in dtDbLinks.Rows)
                {
                    var connStr = new ConnectString
                    {
                        LinkName = dataRow[CiDbLinkDefineTable.FieldLinkName].ToString()
                    };
                    string dbType = dataRow[CiDbLinkDefineTable.FieldLinkType].ToString();
                    switch (dbType.ToUpper())
                    {
                        case "ACCESS":
                            connStr.DbType = CurrentDbType.Access;
                            break;
                        case "ORACLE":
                            connStr.DbType = CurrentDbType.Oracle;
                            break;
                        case "MYSQL":
                            connStr.DbType = CurrentDbType.MySql;
                            break;
                        case "SQLLITE":
                            connStr.DbType = CurrentDbType.SQLite;
                            break;
                        case "DB2":
                            connStr.DbType = CurrentDbType.DB2;
                            break;
                        default:
                            connStr.DbType = CurrentDbType.SqlServer;
                            break;

                    }
                    connStr.DbLink = dataRow[CiDbLinkDefineTable.FieldLinkData].ToString();
                    DbLinks.Add(connStr);
                }
            }
        }

        private void btnTestDgvSummary_Click_1(object sender, EventArgs e)
        {
            FrmTestDgvSummary productAdmin = new FrmTestDgvSummary { DbLinks = this.DbLinks };
            productAdmin.ShowDialog();
        }
    }
}
